#define IN_TYPE       int
#define OUT_TYPE       int
#define BIN_OP(A,B)     ((A)+(B))
#define IDENTITY        0
#define PARA_DEF    ,__global uchar* mpIndex, const int3 count
#define PARA_CALL   ,mpIndex, count


__constant uchar tetraMP2voxMP[6][4]=
{
    {0,6,4,7},
    {0,4,5,7},
    {0,5,1,7},
    {0,1,3,7},
    {0,3,2,7},
    {0,2,6,7}
};
__constant uchar tetraTriangsNum[16]= { 0, 1, 1, 2, 1, 2, 2, 1, 1, 2, 2, 1, 2, 1, 1, 0};

#define K(indx) ((indx)%n.z)
#define J(indx) (((indx)/n.z)%n.y)
#define I(indx) ((indx)/(n.z*n.y))

int Preprocess(int mp, __global uchar* mpIndex, const int3 n)
{
    if(!(I(mp)<n.x-1&&J(mp)<n.y-1&&K(mp)<n.z-1))
    {
        return 0;
    }
    
    uchar myIndex = mpIndex[mp];
    uchar vTriagsNum = 0;
    
    for(int tetra=0;tetra<6;tetra++)
    {
        uchar tetraIndx = 0;
        uchar bit = 1;
        for(uchar l=0;l<4;l++)
        {
            uchar mask = 1 << tetraMP2voxMP[tetra][l];
            tetraIndx+= ((myIndex&mask)>0)*bit;
            bit*=2;
        }
        vTriagsNum += tetraTriangsNum[tetraIndx];
    }
   
    return vTriagsNum;
}


